﻿namespace UltraGridPaging
{
    using System;
    using System.Data;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        private int rows = 1000000;
        private DataSet ds;
        private int start;
        private int end;
        private int pageSize;

        public Form1()
        {
            this.InitializeComponent();
            this.ds = this.CreateData(this.rows);
            this.pageSize = 20;
            this.start = 0;
            this.end = this.pageSize;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetData(this.start, this.end);
        }

        private DataSet GetData(int start, int end)
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add();

            if (this.ds.Tables[0].Rows.Count >= end && start >= 0 && start < end)
            {
                foreach (DataColumn col in this.ds.Tables[0].Columns)
                {
                    dt.Columns.Add(col.Caption, col.DataType);
                }

                for (int row = start; row < end; row++)
                {
                    dt.ImportRow(this.ds.Tables[0].Rows[row]);
                }
            }

            return ds;
        }

        private void ultraButtonPrev_Click(object sender, EventArgs e)
        {
            if (this.start > this.pageSize)
            {
                this.end -= this.pageSize;
                this.start -= this.pageSize;
            }
            else
            {
                this.end = this.pageSize;
                this.start = 0;
            }

            this.ultraGrid1.DataSource = this.GetData(this.start, this.end);
        }

        private void ultraButtonNext_Click(object sender, EventArgs e)
        {
            if (this.end <= this.ds.Tables[0].Rows.Count - this.pageSize)
            {
                this.end += this.pageSize;
                this.start += this.pageSize;
            }
            else
            {
                this.end = this.ds.Tables[0].Rows.Count;
                this.start = this.ds.Tables[0].Rows.Count - this.pageSize;
            }

            this.ultraGrid1.DataSource = this.GetData(this.start, this.end);
        }

        private DataSet CreateData(int rows)
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add();

            dt.Columns.Add("Id", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Name", typeof(string));

            for (int row = 0; row < rows; row++)
            {
                dt.Rows.Add(new object[] { null, string.Format("Row #{0}", row) });
            }

            return ds;
        }

    }
}
